(defun c:2droof3d ( / *error* slope->ang ListClockwise-p mid _ilpp make3dlw acDoc cmde pea ch ent tmp tot big poly reg vl ml ss lst el s )

  (vl-load-com)

  (or acDoc (setq acDoc (vla-get-activedocument (vlax-get-acad-object))))
  (setq ms (vlax-get acDoc (if (= 1 (getvar 'cvport)) 'paperspace 'modelspace)))
  (vla-startundomark acDoc)
  
  (defun *error* ( msg )
    (if cmde (setvar 'cmdecho cmde))
    (if pea (setvar 'peditaccept pea))
    (vla-endundomark acDoc)
    (if msg (prompt msg))
    (princ)
  )

  (defun slope->ang ( sl / v1 v2 *ang )
    (setq v1 (list 0.0 0.0))
    (setq v2 (list 1.0 (/ sl 100.0)))
    (setq *ang (angle v1 v2))
    *ang
  )

  (defun ListClockwise-p ( lst / z vlst )
    (vl-catch-all-apply 'minusp 
      (list
        (if 
          (not 
            (equal 0.0
              (setq z
                (apply '+
                  (mapcar 
                    (function
                      (lambda ( u v )
                        (- (* (car  u) (cadr  v)) (* (car  v) (cadr  u)))
                      )
                    )
                    (setq vlst
                      (mapcar
                        (function
                          (lambda ( a b ) (mapcar '- b a))
                        )
                        (mapcar (function (lambda ( x ) (car lst))) lst) 
                        (cdr (reverse (cons (car lst) (reverse lst))))
                      )
                    )
                    (cdr (reverse (cons (car vlst) (reverse vlst))))
                  )
                )
              ) 1e-6
            )
          )
          z
          (progn
            (prompt "\n\nChecked vectors are colinear - unable to determine clockwise-p of list")
            nil
          )
        )
      )
    )
  )

  (defun mid ( p1 p2 )
    (mapcar '(lambda ( a b ) (/ (+ a b) 2.0)) p1 p2)
  )

  (defun _ilpp ( p1 p2 t1 t2 t3 / v^v unit _ilp nor o )

    (defun v^v ( u v )
      (list
        (- (* (cadr u) (caddr v)) (* (cadr v) (caddr u)))
        (- (* (car  v) (caddr u)) (* (car  u) (caddr v)))
        (- (* (car  u) (cadr  v)) (* (car  v) (cadr  u)))
      )
    )

    (defun unit ( v )
      (mapcar '(lambda ( x ) (/ x (distance '(0.0 0.0 0.0) v))) v)
    )

    (defun _ilp ( p1 p2 o nor / p1p p2p op tp pp p )
      (if (not (equal (v^v nor (unit (mapcar '- p2 p1))) '(0.0 0.0 0.0) 1e-7))
        (progn
          (setq p1p (trans p1 0 (v^v nor (unit (mapcar '- p2 p1))))
                p2p (trans p2 0 (v^v nor (unit (mapcar '- p2 p1))))
                op  (trans o 0 (v^v nor (unit (mapcar '- p2 p1))))
                op  (list (car op) (cadr op) (caddr p1p))
                tp  (polar op (+ (* 0.5 pi) (angle '(0.0 0.0 0.0) (trans nor 0 (v^v nor (unit (mapcar '- p2 p1)))))) 1.0)
          )
          (if (inters p1p p2p op tp nil)
            (progn
              (setq p (trans (inters p1p p2p op tp nil) (v^v nor (unit (mapcar '- p2 p1))) 0))
              p
            )
            nil
          )
        )
        (progn
          (setq pp (list (car (trans p1 0 nor)) (cadr (trans p1 0 nor)) (caddr (trans o 0 nor))))
          (setq p (trans pp nor 0))
          p
        )
      )
    )

    (setq nor (unit (v^v (mapcar '- t3 t1) (mapcar '- t2 t1))))
    (setq o t1)
    
    (if (_ilp p1 p2 o nor)
      (_ilp p1 p2 o nor)
      nil
    )
  )

  (defun make3dlw ( lwp / vl vlu vlup z )
    (setq vl (mapcar 'cdr (acet-list-m-assoc 10 (entget lwp))))
    (setq vl (mapcar '(lambda ( x ) (trans x lwp 0)) vl))
    (setq vlu (mapcar '(lambda ( x ) (_ilpp x (mapcar '+ x '(0.0 0.0 1.0)) (trans '(0.0 0.0 0.0) 1 0) (trans '(1.0 0.0 0.0) 1 0) (trans '(0.0 1.0 0.0) 1 0))) vl))
    (setq vlup (mapcar '(lambda ( x ) (trans x 0 (trans '(0.0 0.0 1.0) 1 0 t))) vlu))
    (setq z (- (caddr (trans '(0.0 0.0 0.0) 0 1))))
    (entmake
      (append
        (list
          '(0 . "LWPOLYLINE")
          '(100 . "AcDbEntity")
          '(100 . "AcDbPolyline")
          (cons 90 (length vl))
          '(70 . 1)
          (cons 38 z)
        )
        (mapcar '(lambda ( x ) (list 10 (car x) (cadr x))) vlup)
        (list (cons 210 (trans '(0.0 0.0 1.0) 1 0 t)))
      )
    )
    (setq vl (mapcar 'cdr (acet-list-m-assoc 10 (entget (entlast)))))
    (setq vl (mapcar '(lambda ( x ) (trans x (entlast) 0)) vl))
    (if (vl-every '(lambda ( x ) (equal (caddr (trans x 0 1)) 0.0 1e-6)) vl)
      (entlast)
      (progn
        (entdel (entlast))
        (setq vlup (mapcar '(lambda ( x ) (trans x 0 1)) vlu))
        (vl-cmdf "_.pline")
        (foreach p vlup
          (vl-cmdf "_non" p)
        )
        (vl-cmdf "_c")
        (entlast)
      )
    )
  )

;-----------------------------------------------------------------------------------------------------------------------------------

  (vl-cmdf "_.ucs" "_w")

  (or slope (setq slope 50))
  (or *ang* (setq *ang* 45))
  (setq tot 0.0)
  (setq cmde (getvar 'cmdecho))
  (setvar 'cmdecho 0)
  (setq pea (getvar 'peditaccept))
  (setvar 'peditaccept 1)

  (initget 1 "Slope Angle")
  (setq ch (getkword "\nInput value [Angle/Slope] : "))
  (if (eq ch "Slope")
    (progn
      (initget 6)
      (setq slope
               (cond
                   ( (getreal (strcat "\nSlope (%)" (if slope (strcat " <" (rtos slope 2 1) ">: ")": "))) )
                   ( slope )
               )
      )
    )
    (progn
      (initget 6)
      (setq *ang*
               (cond
                   ( (getreal (strcat "\nAngle in decimal degrees " (if *ang* (strcat " <" (rtos *ang* 2 1) ">: ")": "))) )
                   ( (float *ang*) )
               )
      )
    )
  )

  (if (eq ch "Slope")
      (setq *ang* (cvunit (slope->ang slope) "radian" "degree"))
      (setq slope (* (/ (sin (* (/ *ang* 180.0) pi)) (cos (* (/ *ang* 180.0) pi))) 100.0))
  )

  (prompt "\nPick contour LWPOLYLINE")
  (setq poly (ssget "_+.:E:S:L" '((0 . "LWPOLYLINE") (-4 . "&=") (70 . 1))))
  (setq poly (ssname poly 0))

  (setq vl (mapcar 'cdr (acet-list-m-assoc 10 (entget poly))))
  (setq vl (mapcar '(lambda ( x ) (trans x poly 0)) vl))
  (if (not (equal (car vl) (last vl) 1e-8)) (setq vl (reverse (cons (car vl) (reverse vl)))))
  (if (ListClockwise-p vl) (setq vl (reverse vl)))
  (setq ml (mapcar '(lambda ( a b ) (mid a b)) vl (cdr vl)))
  
  (vl-cmdf "_.explode" poly)
  (while (< 0 (getvar 'cmdactive)) (vl-cmdf ""))
  
  (prompt "\nSelect 2D roof solution LINE enitites with their contour")
  (while (not ss)
    (if
      (setq ss (ssget '((0 . "LINE"))))
      (progn
        (repeat (setq i (sslength ss))
          (setq lst (cons (vlax-ename->vla-object (ssname ss (setq i (1- i)))) lst))
        )
        (setq reg (vlax-invoke ms 'AddRegion lst))
      )
      (princ "\nEmpty selection...Try again...")
    )
  )

  (foreach r reg
    (setq ent (entlast))
    (vl-cmdf "_.pedit" "_m")
    (apply 'vl-cmdf (mapcar 'vlax-vla-object->ename (vlax-invoke r 'explode)))
    (vl-cmdf "" "_j" "" "")
    (if
      (and
        (not (eq ent (setq ent (entlast))))
        (= "LWPOLYLINE" (cdr (assoc 0 (entget ent))))
      )
      (progn
        (setq tmp (vlax-curve-getarea ent)
              tot (+ tot tmp)
        )
        (if (< (car big) tmp)
          (setq big (list tmp ent))
        )
      )
    )
    (vla-delete r)
  )
  (if (equal (car big) (/ tot 2.0) 1e-3) ;; Gian Paolo Cattaneo
    (entdel (cadr big))
  )
  
  (setq ss (ssadd))

  (mapcar 
   '(lambda ( a b c / p1 p2 zl lw 3dlw )
      (progn
        (setq p1 (osnap (mapcar '+ a (mapcar '* '(0.1 0.1 0.1) (mapcar '- b a))) "_nea")
              p2 (osnap (mapcar '+ a (mapcar '* '(0.9 0.9 0.9) (mapcar '- b a))) "_nea")
              zl (acet-geom-list-extents (list a b))
        )
        (vl-cmdf "_.zoom" "_w" (car zl) (cadr zl))
        (if (eq (sslength (ssget "_CP" (list (polar p1 (+ (angle p1 p2) (* 0.5 pi)) 1e-3) (polar p1 (+ (angle p1 p2) (* -0.5 pi)) 1e-3) (polar p2 (+ (angle p1 p2) (* -0.5 pi)) 1e-3) (polar p2 (+ (angle p1 p2) (* 0.5 pi)) 1e-3)) '((0 . "LWPOLYLINE,LINE")))) 2)
          (progn
            (vl-cmdf "_.ucs" "_3p" "_non" a "_non" b "")
            (vl-cmdf "_.ucs" "_3p" "_non" '(0.0 0.0 0.0) "_non" '(1.0 0.0 0.0) "_non" (list 0.0 (cos (* (/ *ang* 180.0) pi)) (sin (* (/ *ang* 180.0) pi))))
            (if (and (setq s (ssget "_C" (osnap (trans c 0 1) "_mid") (osnap (trans c 0 1) "_nea") '((0 . "LWPOLYLINE")))) (setq lw (ssname s 0)))
              (progn
                (setq 3dlw (make3dlw lw))
                (setq el (entlast))
                (vl-cmdf "_.loft" lw 3dlw "" "")
                (if (not (eq el (entlast)))
                  (progn
                    (ssadd (entlast) ss)
                    (if (entget lw) (entdel lw))
                    (if (entget 3dlw) (entdel 3dlw))
                    (vl-cmdf "_.ucs" "_p")
                    (vl-cmdf "_.ucs" "_p")
                  )
                  (progn
                    (vl-cmdf "_.extrude" lw "" 1e+6 "")
                    (setq el (entlast))
                    (vl-cmdf "_.slice" el "" "_ob" 3dlw "_non" '(0.0 0.0 -1.0))
                    (ssadd el ss)
                    (if (entget lw) (entdel lw))
                    (if (entget 3dlw) (entdel 3dlw))
                    (vl-cmdf "_.ucs" "_p")
                    (vl-cmdf "_.ucs" "_p")
                  )
                )
              )
              (progn
                (vl-cmdf "_.ucs" "_p")
                (vl-cmdf "_.ucs" "_p")
              )
            )
          )
        )
        (vl-cmdf "_.zoom" "_p")
      )
    ) vl (cdr vl) ml
  )
  
  (foreach obj lst (vla-delete obj))
  
  (vl-cmdf "_.union" ss "")
  (vl-cmdf "_.ucs" "_p")
  (*error* nil)
)